blob: 7a4afafa4e23e68a9ff40f88a430503a3f09d39d [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
83 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86
84fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
jeffhao5d1ac922011-09-29 17:41:15 -070093info="info.txt"
94build="build"
95run="run"
96expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070097check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070098output="output.txt"
99build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100100cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700101strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700102lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700103testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700104run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000105build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700106
Alex Light91de25f2015-10-28 17:00:06 -0700107quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000108debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700109prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700110target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700111dev_mode="no"
112update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700113debug_mode="no"
114relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -0800115runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700116usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700117build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700118suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700119trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700120trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700121basic_verify="false"
122gc_verify="false"
123gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700125always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700126never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700127have_dex2oat="yes"
128have_patchoat="yes"
129have_image="yes"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700130pic_image_suffix=""
Jeff Haodcdc85b2015-12-04 14:06:18 -0800131multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000132android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700133bisection_search="no"
Alex Light10bc5a42016-05-10 10:01:22 -0700134# By default we will use optimizing.
135image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000136image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700137
138while true; do
139 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700140 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700141 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100142 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700143 shift
Alex Light91de25f2015-10-28 17:00:06 -0700144 elif [ "x$1" = "x--quiet" ]; then
145 quiet="yes"
146 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700147 elif [ "x$1" = "x--use-java-home" ]; then
148 if [ -n "${JAVA_HOME}" ]; then
149 export JAVA="${JAVA_HOME}/bin/java"
150 export JAVAC="${JAVA_HOME}/bin/javac -g"
151 else
152 echo "Passed --use-java-home without JAVA_HOME variable set!"
153 usage="yes"
154 fi
155 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800156 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700157 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800158 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700159 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700160 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700161 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100162 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100163 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700164 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700165 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800166 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700167 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700168 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700169 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700170 shift
171 elif [ "x$1" = "x--dalvik" ]; then
172 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800173 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700174 shift
Alex Light03a112d2014-08-25 13:25:56 -0700175 elif [ "x$1" = "x--no-dex2oat" ]; then
176 have_dex2oat="no"
177 shift
178 elif [ "x$1" = "x--no-patchoat" ]; then
179 have_patchoat="no"
180 shift
181 elif [ "x$1" = "x--no-image" ]; then
182 have_image="no"
183 shift
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000184 elif [ "x$1" = "x--npic-image" ]; then
185 pic_image_suffix="-npic"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700186 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800187 elif [ "x$1" = "x--multi-image" ]; then
188 multi_image_suffix="-multi"
189 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700190 elif [ "x$1" = "x--pic-test" ]; then
191 run_args="${run_args} --pic-test"
192 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700193 elif [ "x$1" = "x--relocate" ]; then
194 relocate="yes"
195 shift
196 elif [ "x$1" = "x--no-relocate" ]; then
197 relocate="no"
198 shift
199 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100200 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700201 prebuild_mode="yes"
202 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700203 elif [ "x$1" = "x--strip-dex" ]; then
204 run_args="${run_args} --strip-dex"
205 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000206 elif [ "x$1" = "x--debuggable" ]; then
207 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000208 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000209 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700210 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100211 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700212 prebuild_mode="no"
213 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700214 elif [ "x$1" = "x--gcverify" ]; then
215 basic_verify="true"
216 gc_verify="true"
217 shift
218 elif [ "x$1" = "x--gcstress" ]; then
219 basic_verify="true"
220 gc_stress="true"
221 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700222 elif [ "x$1" = "x--image" ]; then
223 shift
224 image="$1"
225 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700226 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000227 elif [ "x$1" = "x-Xcompiler-option" ]; then
228 shift
229 option="$1"
230 run_args="${run_args} -Xcompiler-option $option"
231 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700232 elif [ "x$1" = "x--runtime-option" ]; then
233 shift
234 option="$1"
235 run_args="${run_args} --runtime-option $option"
236 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700237 elif [ "x$1" = "x--gdb-arg" ]; then
238 shift
239 gdb_arg="$1"
240 run_args="${run_args} --gdb-arg $gdb_arg"
241 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700242 elif [ "x$1" = "x--debug" ]; then
243 run_args="${run_args} --debug"
244 shift
245 elif [ "x$1" = "x--gdb" ]; then
246 run_args="${run_args} --gdb"
247 dev_mode="yes"
248 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700249 elif [ "x$1" = "x--strace" ]; then
250 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700251 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700252 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700253 elif [ "x$1" = "x--zygote" ]; then
254 run_args="${run_args} --zygote"
255 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800256 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000257 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700258 image_suffix="-interpreter"
259 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800260 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700261 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000262 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800263 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700264 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700265 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800266 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700267 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700268 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700269 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700270 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700271 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700272 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700273 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700274 elif [ "x$1" = "x--no-optimize" ]; then
275 run_args="${run_args} --no-optimize"
276 shift
277 elif [ "x$1" = "x--no-precise" ]; then
278 run_args="${run_args} --no-precise"
279 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700280 elif [ "x$1" = "x--invoke-with" ]; then
281 shift
282 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700283 if [ "x$what" = "x" ]; then
284 echo "$0 missing argument to --invoke-with" 1>&2
285 usage="yes"
286 break
287 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700288 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700289 shift
290 elif [ "x$1" = "x--dev" ]; then
291 run_args="${run_args} --dev"
292 dev_mode="yes"
293 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700294 elif [ "x$1" = "x--build-only" ]; then
295 build_only="yes"
296 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100297 elif [ "x$1" = "x--build-with-javac-dx" ]; then
298 USE_JACK="false"
299 shift
300 elif [ "x$1" = "x--build-with-jack" ]; then
301 USE_JACK="true"
302 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700303 elif [ "x$1" = "x--output-path" ]; then
304 shift
305 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700306 if [ "x$tmp_dir" = "x" ]; then
307 echo "$0 missing argument to --output-path" 1>&2
308 usage="yes"
309 break
310 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700311 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000312 elif [ "x$1" = "x--android-root" ]; then
313 shift
314 if [ "x$1" = "x" ]; then
315 echo "$0 missing argument to --android-root" 1>&2
316 usage="yes"
317 break
318 fi
319 android_root="$1"
320 run_args="${run_args} --android-root $1"
321 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700322 elif [ "x$1" = "x--update" ]; then
323 update_mode="yes"
324 shift
325 elif [ "x$1" = "x--help" ]; then
326 usage="yes"
327 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700328 elif [ "x$1" = "x--64" ]; then
329 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700330 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700331 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200332 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700333 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200334 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700335 elif [ "x$1" = "x--stream" ]; then
336 trace_stream="true"
337 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700338 elif [ "x$1" = "x--always-clean" ]; then
339 always_clean="yes"
340 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700341 elif [ "x$1" = "x--never-clean" ]; then
342 never_clean="yes"
343 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800344 elif [ "x$1" = "x--dex2oat-swap" ]; then
345 run_args="${run_args} --dex2oat-swap"
346 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700347 elif [ "x$1" = "x--instruction-set-features" ]; then
348 shift
349 run_args="${run_args} --instruction-set-features $1"
350 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700351 elif [ "x$1" = "x--bisection-search" ]; then
352 bisection_search="yes"
353 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700354 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700355 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700356 usage="yes"
357 break
358 else
359 break
360 fi
361done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700362
Alex Light10bc5a42016-05-10 10:01:22 -0700363run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700364# Allocate file descriptor real_stderr and redirect it to the shell's error
365# output (fd 2).
366if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
367 exec {real_stderr}>&2
368else
369 # In bash before version 4.1 we need to do a manual search for free file
370 # descriptors.
371 FD=3
372 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
373 real_stderr=$FD
374 eval "exec ${real_stderr}>&2"
375fi
376if [ "$quiet" = "yes" ]; then
377 # Force the default standard output and error to go to /dev/null so we will
378 # not print them.
379 exec 1>/dev/null
380 exec 2>/dev/null
381fi
382
383function err_echo() {
384 echo "$@" 1>&${real_stderr}
385}
386
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700387# tmp_dir may be relative, resolve.
388#
389# Cannot use realpath, as it does not exist on Mac.
390# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700391# Cannot use readlink -m, as it does not exist on Mac.
392# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700393noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700394tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700395mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700396
Alex Lighte7873ec2014-08-12 09:53:50 -0700397if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800398 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
399 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700400fi
401if [ "$gc_verify" = "true" ]; then
402 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
403fi
404if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700405 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700406fi
Jeff Hao85139a32014-07-23 11:52:52 -0700407if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700408 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
409 if [ "$trace_stream" = "true" ]; then
410 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
411 # the ability to analyze the file and just write to /dev/null.
412 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
413 # Enable streaming mode.
414 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
415 else
416 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
417 fi
418elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700419 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700420 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700421fi
422
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700423# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100424# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100425function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100426 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800427 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700428 if [ "x${suffix64}" = "x64" ]; then
429 target_arch_name=${grep64bit}
430 else
431 target_arch_name=${grep32bit}
432 fi
433}
434
David Brazdil853a4c32015-09-28 16:15:50 +0100435function guess_host_arch_name() {
436 if [ "x${suffix64}" = "x64" ]; then
437 host_arch_name="x86_64"
438 else
439 host_arch_name="x86"
440 fi
441}
442
Alex Lighta59dd802014-07-02 16:28:08 -0700443if [ "$target_mode" = "no" ]; then
444 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700445 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700446 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700447 exit 1;
448 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700449 fi
450fi
451
Alex Light03a112d2014-08-25 13:25:56 -0700452if [ "$have_patchoat" = "no" ]; then
453 run_args="${run_args} --no-patchoat"
454fi
455
456if [ "$have_dex2oat" = "no" ]; then
457 run_args="${run_args} --no-dex2oat"
458fi
459
Jeff Hao201803f2013-11-20 18:11:39 -0800460if [ ! "$runtime" = "jvm" ]; then
461 run_args="${run_args} --lib $lib"
462fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700463
Jeff Hao201803f2013-11-20 18:11:39 -0800464if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700465 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100466 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800467 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700468 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700469 else
470 true # defaults to using target BOOTCLASSPATH
471 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800472elif [ "$runtime" = "art" ]; then
473 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100474 guess_host_arch_name
Jeff Haodcdc85b2015-12-04 14:06:18 -0800475 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700476 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800477 else
David Brazdil853a4c32015-09-28 16:15:50 +0100478 guess_target_arch_name
Nicolas Geoffrayf13a3652016-09-22 22:55:58 +0100479 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}:${android_root}/lib${suffix64}"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800480 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800481 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700482 if [ "$relocate" = "yes" ]; then
483 run_args="${run_args} --relocate"
484 else
485 run_args="${run_args} --no-relocate"
486 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700487elif [ "$runtime" = "jvm" ]; then
488 # TODO: Detect whether the host is 32-bit or 64-bit.
489 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700490fi
491
Alex Light03a112d2014-08-25 13:25:56 -0700492if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700493 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700494 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700495 exit 1
496 fi
497 if [ "$target_mode" = "no" ]; then
498 framework="${ANDROID_HOST_OUT}/framework"
499 bpath_suffix="-hostdex"
500 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000501 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700502 bpath_suffix=""
503 fi
504 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
505 # fail since these jar files will be stripped.
506 bpath="${framework}/core-libart${bpath_suffix}.jar"
Narayan Kamathd50687e2015-11-17 12:37:27 +0000507 bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700508 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
509 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700510 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
511 # Pass down the bootclasspath
512 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700513 run_args="${run_args} --no-image"
514fi
515
jeffhao5d1ac922011-09-29 17:41:15 -0700516if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700517 err_echo "--dev and --update are mutually exclusive"
518 usage="yes"
519fi
520
521if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
522 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700523 usage="yes"
524fi
525
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700526if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
527 err_echo "--bisection-search and --prebuild are mutually exclusive"
528 usage="yes"
529fi
530
531if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
532 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
533 usage="yes"
534fi
535
536if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
537 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
538 usage="yes"
539fi
540
jeffhao5d1ac922011-09-29 17:41:15 -0700541if [ "$usage" = "no" ]; then
542 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
543 test_dir=`basename "$oldwd"`
544 else
545 test_dir="$1"
546 fi
547
548 if [ '!' -d "$test_dir" ]; then
549 td2=`echo ${test_dir}-*`
550 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700551 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700552 usage="yes"
553 fi
554 test_dir="$td2"
555 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700556 # Shift to get rid of the test name argument. The rest of the arguments
557 # will get passed to the test run.
558 shift
559fi
560
Søren Gjesse620d0a52016-09-19 11:12:51 +0200561# For building with javac and dx always use Java 7. The dx compiler
562# only support byte codes from Java 7 or earlier (class file major
563# version 51 or lower).
564if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
565 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
566fi
567
jeffhao5d1ac922011-09-29 17:41:15 -0700568if [ "$usage" = "yes" ]; then
569 prog=`basename $prog`
570 (
571 echo "usage:"
572 echo " $prog --help Print this message."
573 echo " $prog [options] [test-name] Run test normally."
574 echo " $prog --dev [options] [test-name] Development mode" \
575 "(dumps to stdout)."
576 echo " $prog --update [options] [test-name] Update mode" \
577 "(replaces expected.txt)."
578 echo ' Omitting the test name or specifying "-" will use the' \
579 "current directory."
580 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000581 echo " -O Run non-debug rather than debug build (off by default)."
582 echo " -Xcompiler-option Pass an option to the compiler."
583 echo " --runtime-option Pass an option to the runtime."
584 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000585 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000586 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700587 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000588 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200589 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
590 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000591 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800592 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000593 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000594 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700595 echo " --verify-soft-fail Force soft fail verification (off by default)."
596 echo " Verification is enabled if neither --no-verify"
597 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000598 echo " --no-optimize Turn off optimization (on by default)."
599 echo " --no-precise Turn off precise GC (on by default)."
600 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700601 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000602 echo " other runtime options are ignored."
603 echo " --no-dex2oat Run as though dex2oat was failing."
604 echo " --no-patchoat Run as though patchoat was failing."
605 echo " --prebuild Run dex2oat on the files before starting test. (default)"
606 echo " --no-prebuild Do not run dex2oat on the files before starting"
607 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700608 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000609 echo " --relocate Force the use of relocating in the test, making"
610 echo " the image and oat files be relocated to a random"
611 echo " address before running. (default)"
612 echo " --no-relocate Force the use of no relocating in the test"
Alex Lightfadfee92015-10-28 09:40:10 -0700613 echo " --image Run the test using a precompiled boot image. (default)"
614 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000615 echo " --host Use the host-mode virtual machine."
616 echo " --invoke-with Pass --invoke-with option to runtime."
617 echo " --dalvik Use Dalvik (off by default)."
618 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700619 echo " --use-java-home Use the JAVA_HOME environment variable"
620 echo " to find the java compiler and runtime"
621 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000622 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700623 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000624 echo " --64 Run the test in 64-bit mode"
625 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700626 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700627 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000628 echo " --gcstress Run with gc stress testing"
629 echo " --gcverify Run with gc verification"
630 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700631 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000632 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000633 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700634 echo " --instruction-set-features [string]"
635 echo " Set instruction-set-features for compilation."
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000636 echo " --npic-image Use an image compiled with non-position independent code "
637 echo " for the boot class path."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800638 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
639 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700640 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700641 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700642 echo " --bisection-search Perform bisection bug search."
Alex Light91de25f2015-10-28 17:00:06 -0700643 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700644 exit 1
645fi
646
647cd "$test_dir"
648test_dir=`pwd`
649
650td_info="${test_dir}/${info}"
651td_expected="${test_dir}/${expected}"
652
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700653if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700654 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700655 exit 1
656fi
657
658if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700659 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700660 exit 1
661fi
662
663# copy the test to a temp dir and run it
664
Elliott Hughes510c8782011-10-06 10:57:34 -0700665echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700666
667rm -rf "$tmp_dir"
668cp -Rp "$test_dir" "$tmp_dir"
669cd "$tmp_dir"
670
671if [ '!' -r "$build" ]; then
672 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800673else
674 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700675fi
676
677if [ '!' -r "$run" ]; then
678 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800679else
680 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700681fi
682
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700683if [ '!' -r "$check_cmd" ]; then
684 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800685else
686 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700687fi
688
jeffhao5d1ac922011-09-29 17:41:15 -0700689chmod 755 "$build"
690chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700691chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700692
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700693export TEST_NAME=`basename ${test_dir}`
694
Roland Levillain0d5a2812015-11-13 10:07:31 +0000695# arch_supports_read_barrier ARCH
696# -------------------------------
697# Return whether the Optimizing compiler has read barrier support for ARCH.
698function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000699 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000700 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000701 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000702}
703
David Brazdil4846d132015-01-15 19:07:08 +0000704# Tests named '<number>-checker-*' will also have their CFGs verified with
705# Checker when compiled with Optimizing on host.
706if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000707 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000708 # Optimizing has read barrier support for certain architectures
709 # only. On other architectures, compiling is disabled when read
710 # barriers are enabled, meaning that we do not produce a CFG file
711 # as a side-effect of compilation, thus the Checker assertions
712 # cannot be checked. Disable Checker for those cases.
713 #
714 # TODO: Enable Checker when read barrier support is added to more
715 # architectures (b/12687968).
716 if [ "x$ART_USE_READ_BARRIER" = xtrue ] \
717 && (([ "x$host_mode" = "xyes" ] \
718 && ! arch_supports_read_barrier "$host_arch_name") \
719 || ([ "x$target_mode" = "xyes" ] \
720 && ! arch_supports_read_barrier "$target_arch_name")); then
721 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100722 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
723 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000724 elif [ "$prebuild_mode" = "yes" ] \
725 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100726 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100727
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100728 if [ "$target_mode" = "no" ]; then
729 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100730 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100731 else
732 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100733 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100734 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100735
736 if [ "$debuggable" = "yes" ]; then
737 checker_args="$checker_args --debuggable"
738 fi
739
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100740 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100741 -Xcompiler-option -j1"
742 fi
David Brazdil4846d132015-01-15 19:07:08 +0000743 fi
744fi
745
Mathieu Chartier031768a2015-08-27 10:25:02 -0700746 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700747
Ian Rogers997f0f92014-06-21 22:58:05 -0700748# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100749build_file_size_limit=2048
750run_file_size_limit=2048
Alex Light4694e822016-01-22 10:09:40 -0800751
752# Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with
753# large amounts of expected output or large generated files.
754if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100755 build_file_size_limit=5120
756 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700757fi
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100758if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then
759 # We will need to `adb pull` the .cfg output from the target onto the host to
760 # run checker on it. This file can be big.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000761 build_file_size_limit=24576
762 run_file_size_limit=24576
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100763fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100764if [ ${USE_JACK} = "false" ]; then
765 # Set ulimit if we build with dx only, Jack can generate big temp files.
766 if ! ulimit -S "$build_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700767 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100768 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700769fi
770
jeffhao5d1ac922011-09-29 17:41:15 -0700771good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000772good_build="yes"
773good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700774if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000775 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700776 build_exit="$?"
777 echo "build exit status: $build_exit" 1>&2
778 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100779 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700780 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100781 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800782 echo "${test_dir}: running..." 1>&2
783 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700784 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000785
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800786 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000787 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100788 if [ "$target_mode" = "yes" ]; then
789 adb pull $cfg_output_dir/$cfg_output &> /dev/null
790 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100791 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000792 checker_exit="$?"
793 if [ "$checker_exit" = "0" ]; then
794 good="yes"
795 fi
Alex Light91de25f2015-10-28 17:00:06 -0700796 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000797 else
798 good="yes"
799 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800800 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000801 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700802 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700803elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000804 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700805 build_exit="$?"
806 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100807 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700808 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100809 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800810 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700811 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000812 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100813 if [ "$target_mode" = "yes" ]; then
814 adb pull $cfg_output_dir/$cfg_output &> /dev/null
815 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100816 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000817 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700818 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
819 good="yes"
820 else
Alex Light91de25f2015-10-28 17:00:06 -0700821 cat "$build_output" 1>&${real_stderr} 1>&2
822 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700823 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700824elif [ "$build_only" = "yes" ]; then
825 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000826 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700827 build_exit="$?"
828 if [ "$build_exit" '!=' '0' ]; then
829 cp "$build_output" "$output"
830 echo "build exit status: $build_exit" >>"$output"
831 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
832 if [ "$?" '!=' "0" ]; then
833 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700834 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700835 fi
836 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700837 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700838 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700839 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700840else
David Brazdil4846d132015-01-15 19:07:08 +0000841 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700842 build_exit="$?"
843 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100844 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700845 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100846 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800847 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700848 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000849 run_exit="$?"
850 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700851 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000852 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000853 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100854 if [ "$target_mode" = "yes" ]; then
855 adb pull $cfg_output_dir/$cfg_output &> /dev/null
856 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100857 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000858 checker_exit="$?"
859 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700860 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000861 good_run="no"
862 else
863 good_run="yes"
864 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000865 else
866 good_run="yes"
867 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700868 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000869 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700870 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700871 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
872 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700873 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700874 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700875 max_name_length=$(getconf NAME_MAX ${tmp_dir})
876 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
877 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700878 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700879 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700880 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700881 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000882 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
883 # output == expected
884 good="yes"
885 echo "${test_dir}: succeeded!" 1>&2
886 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700887 fi
888fi
889
jeffhao5d1ac922011-09-29 17:41:15 -0700890(
Alex Lightbfac14a2014-07-30 09:41:21 -0700891 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700892 echo "${test_dir}: FAILED!"
893 echo ' '
894 echo '#################### info'
895 cat "${td_info}" | sed 's/^/# /g'
896 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700897 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700898 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700899 if [ "$strace" = "yes" ]; then
900 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700901 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700902 echo '####################'
903 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700904 echo ' '
905 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700906
Alex Light91de25f2015-10-28 17:00:06 -0700907) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700908
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700909# Attempt bisection only if the test failed.
910if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
911 # Bisecting works by skipping different optimization passes which breaks checker assertions.
912 if [ "$run_checker" == "yes" ]; then
913 echo "${test_dir}: not bisecting, checker test." 1>&2
914 else
915 # Increase file size limit, bisection search can generate large logfiles.
916 if ! ulimit -S unlimited; then
917 err_echo "ulimit file size setting failed"
918 fi
919 echo "${test_dir}: bisecting..." 1>&2
920 cwd=`pwd`
921 maybe_device_mode=""
922 raw_cmd=""
923 if [ "$target_mode" = "yes" ]; then
924 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
925 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
926 # to exec in order to preserve pid when calling dalvikvm. This is required
927 # for bisection search to correctly retrieve logs from device.
928 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
929 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
930 maybe_device_mode="--device"
931 raw_cmd="$DEX_LOCATION/cmdline.sh"
932 else
933 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
934 fi
935 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
936 $maybe_device_mode \
937 --raw-cmd="$raw_cmd" \
938 --check-script="$cwd/check" \
939 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700940 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700941 --timeout=300
942 fi
943fi
944
Alex Lightbfac14a2014-07-30 09:41:21 -0700945# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700946if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700947 cd "$oldwd"
948 rm -rf "$tmp_dir"
949 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
950 adb shell rm -rf $DEX_LOCATION
951 fi
952 if [ "$good" = "yes" ]; then
953 exit 0
954 fi
955fi
956
957
958(
959 if [ "$always_clean" = "yes" ]; then
960 echo "${TEST_NAME} files deleted from host "
961 if [ "$target_mode" == "yes" ]; then
962 echo "and from target"
963 fi
964 else
965 echo "${TEST_NAME} files left in ${tmp_dir} on host"
966 if [ "$target_mode" == "yes" ]; then
967 echo "and in ${DEX_LOCATION} on target"
968 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700969 fi
970
Alex Light91de25f2015-10-28 17:00:06 -0700971) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700972
Alex Light6a870fa2016-05-31 16:36:19 -0700973if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
974 exit 0
975else
976 exit 1
977fi